Subject: bug#18499: closed (Re: bug#18499: Possible mv race for hardlinks (rhbz #1141368 ))

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 21 Nov 2014 11:54:02 +0000

Your bug report

#18499: Possible mv race for hardlinks (rhbz #1141368 )

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
18499: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=18499
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#18499: Possible mv race for hardlinks (rhbz #1141368 )
From: Pádraig Brady <[email-masked]>
To: Boris Ranto <[email-masked]>
Cc: Paul Eggert <[email-masked]>, [email-masked], [email-masked], Miklos Szeredi <[email-masked]>
Date: Fri, 21 Nov 2014 11:53:28 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On 21/11/14 08:29, Boris Ranto wrote:
> On Fri, 2014-11-21 at 03:30 +0000, Pádraig Brady wrote:
>> We want to leave the logic in place for cp and install though,
>> and I've adjusted your patch accordingly. I've also adjusted
>> the tests to pass and augmented the tests to cover one of
>> the cases missed in the previous patch.  I'll push this tomorrow.
>>
>> thanks,
>> Pádraig.
> 
> Just a note: cp already presented this behaviour before the patch, i.e. 
> 
> cp a b
> 
> on hard links to the same file failed with 
> 
> cp: ‘a’ and ‘b’ are the same file
> 
> On the other hand, install does not present it, it copies over b
> creating new inode for b.

Yep, but there were other cases with `cp -a` with hardlinks
to symlinks, and cp --remove-destination a b.

I've pushed that now.

thanks!
Pádraig.

Subject: Possible mv race for hardlinks (rhbz #1141368 )
From: Ondrej Vasik <[email-masked]>
To: CoreutilsBugs <[email-masked]>
Date: Thu, 18 Sep 2014 12:52:32 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,
as reported in https://bugzilla.redhat.com/show_bug.cgi?id=1141368 ,
there is a possible race condition in mv in the case of hardlinks.

Bug is reproducible even on ext4 filesystem (I guess it is filesystem
independent), even with the latest coreutils. There was already attempt
to fix the non-atomicity of mv for hardlinks
( http://thread.gmane.org/gmane.comp.gnu.coreutils.bugs/12985 ), from
the current reproducer it looks like the fix is probably incomplete.

Regards,
       Ondrej Vasik